#ifndef _TRANSACTIONENUMERATOR_H
#define _TRANSACTIONENUMERATOR_H

#include <string>
#include "lib/enumerator.hpp"
#include "lib/seqinfileenumerator.hpp"
#include "record.h"

class TransactionEnumerator : public Enumerator<Record>
{
   protected:
      SeqInFileEnumerator<Record> *fit;
      Record current;
      bool end;
   public:
      TransactionEnumerator(const std::string &str)
      {
         fit = new SeqInFileEnumerator<Record>(str);
      }
      void First()
      {
         fit->First();
         Next();
      }
      void Next();
      bool End() const { return end;}
      Record Current() const { return current; }
      ~TransactionEnumerator() { delete fit; }
};

#endif

